#ifndef GETSTREAM_H
#define GETSTREAM_H

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <event.h>

#define DEBUG

#ifdef DEBUG
#define dprintf		printf
#else
#define dprintf( a... )
#endif

#define	MAX_CTL_MSG_SIZE	1500

/*
 *
 *
 * getstream.c
 *
 *
 */

extern int debuglvl;

struct channel_s {
	/* Config elements */
	struct channel_s	*next;
	int			id;
	struct stream_s		*stream;

	/* */
	struct dvbrc_channel_s	*dvbchannel;

	/* Demux */
	unsigned int		apid, vpid, opid, ppid;
	char			pid0cc;
};

struct adapter_s {
	struct adapter_s		*next;
	int				no;
	struct channel_s		*channel;
	struct dvbrc_transponder_s	*transponder;
	/* Frontend */
	int				fefd;
};

#include "stream.h"

/*
 *
 *
 * fe.c
 *
 *
 */
int fe_tune(struct adapter_s	*adapter);

/*
 *
 *
 * demux.c
 *
 *
 *
 */
#define MAX_MCAST_PAYLOAD	(1500-40)
#define TS_PACKET_SIZE		188
#define DVR_BUFFER_SIZE		188*10
#define MAX_PID			0x1fff

enum {
	PID_NONE,
	PID_PMT,
	PID_VIDEO,
	PID_AUDIO,
	PID_OTHER
};

struct pidentry_s {
	unsigned char		type,
				cc;
	time_t			lastvalid;
	struct channel_s	*channel;
};

int demux_init(struct adapter_s *adapter);

/*
 *
 *
 * util.c
 *
 *
 */

int addr_is_mcast(char *addr);
void dump_hex(uint8_t *buf, int size);
void ts_packet_decode(uint8_t *ts);

#endif
