

#include <arpa/inet.h>
#include <netinet/in.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#include "stream.h"
#include "getstream.h"
#include "dvbrc.h"

inline void stream_send(struct channel_s *channel, uint8_t *tsp) {
	struct stream_s		*s;

	for(s=channel->stream;s;s=s->next) {
		/* Does this stream output have receiver */
		if (s->receiver == 0)
			continue;
		switch(s->type) {
			case(STYPE_UDP):
				stream_send_udp(s, tsp);
				break;
			case(STYPE_RTP):
			case(STYPE_RTCP):
				stream_send_rtp(s, tsp);
				break;
			case(STYPE_HTTP):
				stream_send_http(s, tsp);
				break;
		}
	}
}

int stream_init(struct stream_s *stream) {
	struct stream_s		*s;

	for(s=stream;s;s=s->next) {
		/* Initialize all stream outputs for this stream */
		switch(s->type) {
			case(STYPE_HTTP):
				stream_init_http(s);
				break;
			case(STYPE_UDP):
				stream_init_udp(s);
				break;
			case(STYPE_RTP):
			case(STYPE_RTCP):
				stream_init_rtp(s);
				break;
		}
	}
	return 1;
}

